%-\delta u+ga^2*u=0 in Omega, du/dn=lambda*u on D\Omega, ga>0. 
global ga xb yb xm ym bel nbp aa L_da U_da x_t y_t n_t n_p;
global da e_d_order e_v_order;   %all vectors are in column

%u=aa&eta, du/dn=lambda*u<=>da*eta=\lambda*aa*eta
%D=diag(d_1,...,d_n) e-values and V=(v_1,...v_n) e-vectors  eta_i=v_i

   [eig_v,eig_d]=eig(da,aa); %da*eig_v=eig_d*aa*eig_v

%Densities of e-functions and their normal derivatives are found
    for i=1:nbp     %Sort them in the order of e-values 
      e_d(i)=eig_d(i,i);
    end
      [e_d_order, ind_e]=sort(e_d);

    for i=1:nbp
      e_v_order(:,i)=eig_v(:,ind_e(i));
    end

ans_0=1;
while ans_0==1
nth=input('Type the nth number of eigenfunction you want to see, nth=');
disp('The nth eigen-value =');
  lambda=e_d_order(nth)
%Turn densities into e-functions on the boundary 
  eta=e_v_order(:,nth); %Take the nth eigen density
  u_b=aa*eta;           %nth eigenfunction on the boundary
  d_u_b=lambda*eta;     %=da*eta
  norm=sqrt(bel'*(d_u_b.*u_b)); %normalizing
  u_b=u_b/norm;
  d_u_b=d_u_b/norm;

ans=input('Plot the Solution along the boundary? 1=yes,0=no-->');
if ans==1 
   u_0=[u_b(:);u_b(1)];
   x_tmp=linspace(0,2*pi,nbp+1);
   plot(x_tmp,u_0);
end

ans=input('Plot the Solution in the domain? 1=yes,0=no-->');
if ans==1   %level_1

%Evaluate the solution inside the domain
%[u_c]=solution_inside(eta);

[rint,wint]=gpt_dat;      %get Guass points and weights
ng = 4;    ng2=ng-1;      % use 4-point Gauss integration formula

u_c=zeros(n_t,1);

if ga <= 10.^(-8)
for i=1:n_t
%   u_c(i)=0;
  for j=1:nbp
    ax = xb(j);
    bx = xb(j+1);
    ay = yb(j);
    by = yb(j+1);
    for k=1:ng           %Gauss integration
      gx = 0.5*((bx-ax)*rint(ng2,k)+bx+ax);
      gy = 0.5*((by-ay)*rint(ng2,k)+by+ay);
      gc = 0.5*bel(j)*wint(ng2,k)*eta(j);
      dis = sqrt((x_t(i)-gx)^2+(y_t(i)-gy)^2);
      u_c(i) = u_c(i)-gc/(2*pi)*log(dis);
    end
  end
end
else
for i=1:n_t
%   u_c(i)=0;
  for j=1:nbp
    ax = xb(j);
    bx = xb(j+1);
    ay = yb(j);
    by = yb(j+1);
    for k=1:ng           %Gauss integration
      gx = 0.5*((bx-ax)*rint(ng2,k)+bx+ax);
      gy = 0.5*((by-ay)*rint(ng2,k)+by+ay);
      gc = 0.5*bel(j)*wint(ng2,k)*eta(j);
      dis = sqrt((x_t(i)-gx)^2+(y_t(i)-gy)^2);
      wk = ga*dis;
      u_c(i) = u_c(i)+gc/(2*pi)*besselk(0,wk);
    end
  end
end
end %inside evaluation

plot3(xb,yb,zeros(nbp+1)); hold on; 
%plot the boundary in the graph. It may not look good for Neumann BC.
u_max=max(u_c);
pdecont(p,t,u_c,50); hold on;       %Plot contours 
pdemesh(p,e,t,u_c-1.5*u_max);
%pdemesh(p,e,t,u_c);
%pdesurf(p,t,u_c); drawnow;
end  %Level_1


disp('If you are ready, hit any key to continue');

pause;


ans_0=input('Need to see another eigenfunction? 1=yes,0=no-->');
 if ans_0==0
  break;
 end
end %while ans_0

